<?php
/**
 * Template for a modal
 *
 * Please see wp-cookie-allow.php for more details.
 *
 * @author $Author: Vincent Weber <vincent@webrtistik.nl> $
 *
 * @since 3.2.11
 */
if( ! defined( 'ABSPATH' ) ) exit;
?>
<div id="wpca-popup-modal" class="wpca-hide">
	<?php // content is escaped in the module with `wp_kses`
	echo $content ?><svg
		version="1.1"
		class="wpca-icon-close"
		xmlns="http://www.w3.org/2000/svg"
		xmlns:xlink="http://www.w3.org/1999/xlink"
		x="0px"
		y="0px"
		width="20px"
		height="20px"
		viewBox="0 0 20 20"
		enable-background="new 0 0 20 20"
		xml:space="preserve">
		<title>WeePie Cookie Allow close cookie category settings pop-up icon</title>
		<polygon fill-rule="evenodd" points="19,3.581 16.42,1 10,7.42 3.581,1 1,3.58 7.42,10 1,16.42 3.581,19 10,12.581 16.42,19 19,16.419 12.581,10" fill="<?php echo $color_close_x_icon ?>"/>
	</svg>
</div>